/* -- THIS FILE IS GENERATED - DO NOT EDIT *//* -*- Mode: C; c-basic-offset: 4 -*- */

#define PY_SSIZE_T_CLEAN
#include <Python.h>




#if PY_VERSION_HEX < 0x02050000
typedef int Py_ssize_t;
#define PY_SSIZE_T_MAX INT_MAX
#define PY_SSIZE_T_MIN INT_MIN
typedef inquiry lenfunc;
typedef intargfunc ssizeargfunc;
typedef intobjargproc ssizeobjargproc;
#endif


#line 3 "./cogl.override"
#define NO_IMPORT_PYGOBJECT
#include "pygobject.h"

#include "pyclutter-private.h"

#include <cogl/cogl.h>

static gpointer
pycogl_handle_ref (gpointer data)
{
  if (G_LIKELY (data))
    {
      CoglHandle hnd = data;

      if (hnd == COGL_INVALID_HANDLE)
        return NULL;

      if (cogl_is_texture (hnd))
        return cogl_texture_ref (hnd);
      else if (cogl_is_shader (hnd))
        return cogl_shader_ref (hnd);
      else if (cogl_is_program (hnd))
        return cogl_program_ref (hnd);
      else if (cogl_is_offscreen (hnd))
        return cogl_offscreen_ref (hnd);
      else
        g_assert_not_reached ();
    }

  return NULL;
}

static void
pycogl_handle_unref (gpointer data)
{
  if (G_LIKELY (data))
    {
      CoglHandle hnd = data;

      if (hnd == COGL_INVALID_HANDLE)
        return;

      if (cogl_is_texture (hnd))
        cogl_texture_unref (hnd);
      else if (cogl_is_shader (hnd))
        cogl_shader_unref (hnd);
      else if (cogl_is_program (hnd))
        cogl_program_unref (hnd);
      else if (cogl_is_offscreen (hnd))
        cogl_offscreen_unref (hnd);
      else
        g_assert_not_reached ();
    }
}

GType
pycogl_handle_get_type (void)
{
  static GType hnd_type = 0;

  if (G_UNLIKELY (hnd_type == 0))
    hnd_type = g_boxed_type_register_static (g_intern_static_string ("CoglHandle"),
                                             pycogl_handle_ref,
                                             pycogl_handle_unref);

  return hnd_type;
}
#line 88 "cogl.c"


/* ---------- types from other modules ---------- */


/* ---------- forward type declarations ---------- */
PyTypeObject G_GNUC_INTERNAL PyCoglHandle_Type;

#line 97 "cogl.c"



/* ----------- CoglHandle ----------- */

static int
pygobject_no_constructor(PyObject *self, PyObject *args, PyObject *kwargs)
{
    gchar buf[512];

    g_snprintf(buf, sizeof(buf), "%s is an abstract widget", self->ob_type->tp_name);
    PyErr_SetString(PyExc_NotImplementedError, buf);
    return -1;
}

static PyObject *
_wrap_cogl_is_texture(PyObject *self)
{
    int ret;

    
    ret = cogl_is_texture(pyg_boxed_get(self, CoglHandle));
    
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_cogl_texture_get_width(PyObject *self)
{
    guint ret;

    
    ret = cogl_texture_get_width(pyg_boxed_get(self, CoglHandle));
    
    return PyLong_FromUnsignedLong(ret);
}

static PyObject *
_wrap_cogl_texture_get_height(PyObject *self)
{
    guint ret;

    
    ret = cogl_texture_get_height(pyg_boxed_get(self, CoglHandle));
    
    return PyLong_FromUnsignedLong(ret);
}

static PyObject *
_wrap_cogl_texture_get_format(PyObject *self)
{
    gint ret;

    
    ret = cogl_texture_get_format(pyg_boxed_get(self, CoglHandle));
    
    return pyg_enum_from_gtype(PYCOGL_TYPE_PIXEL_FORMAT, ret);
}

static PyObject *
_wrap_cogl_texture_get_rowstride(PyObject *self)
{
    guint ret;

    
    ret = cogl_texture_get_rowstride(pyg_boxed_get(self, CoglHandle));
    
    return PyLong_FromUnsignedLong(ret);
}

static PyObject *
_wrap_cogl_texture_get_max_waste(PyObject *self)
{
    int ret;

    
    ret = cogl_texture_get_max_waste(pyg_boxed_get(self, CoglHandle));
    
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_cogl_texture_get_min_filter(PyObject *self)
{
    int ret;

    
    ret = cogl_texture_get_min_filter(pyg_boxed_get(self, CoglHandle));
    
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_cogl_texture_get_mag_filter(PyObject *self)
{
    int ret;

    
    ret = cogl_texture_get_mag_filter(pyg_boxed_get(self, CoglHandle));
    
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_cogl_texture_is_sliced(PyObject *self)
{
    int ret;

    
    ret = cogl_texture_is_sliced(pyg_boxed_get(self, CoglHandle));
    
    return PyBool_FromLong(ret);

}

#line 245 "cogl-texture.override"
static PyObject *
_wrap_cogl_texture_get_gl_texture (PyObject *self)
{
    CoglHandle hnd = pyg_boxed_get (self, CoglHandle);
    GLuint gl_handle = 0;
    GLenum gl_target = 0;

    if (cogl_is_texture (hnd)) {
        cogl_texture_get_gl_texture (hnd, &gl_handle, &gl_target);

        return Py_BuildValue ("(ii)", gl_handle, gl_target);
    }

    return Py_BuildValue ("()");
}
#line 230 "cogl.c"


static PyObject *
_wrap_cogl_texture_set_filters(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "min_filter", "max_filter", NULL };
    int min_filter, max_filter;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ii:CoglHandle.set_filters", kwlist, &min_filter, &max_filter))
        return NULL;
    
    cogl_texture_set_filters(pyg_boxed_get(self, CoglHandle), min_filter, max_filter);
    
    Py_INCREF(Py_None);
    return Py_None;
}

#line 262 "cogl-texture.override"
static PyObject *
_wrap_cogl_texture_rectangle (PyObject *self,
                              PyObject *args,
                              PyObject *kwargs)
{
    static char *kwlist[] = { "x1", "y1", "x2", "y2", "tx1", "ty1", "tx2", "ty2", NULL };
    CoglHandle hnd = pyg_boxed_get (self, CoglHandle);
    double x1, y1, x2, y2;
    double tx1, ty1, tx2, ty2;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "dddddddd:CoglHandle.texture_rectangle", kwlist,
                                     &x1, &y1, &x2, &y2,
                                     &tx1, &ty1, &tx2, &ty2))
        return NULL;

    cogl_texture_rectangle (hnd,
                            CLUTTER_FLOAT_TO_FIXED (x1),
                            CLUTTER_FLOAT_TO_FIXED (y1),
                            CLUTTER_FLOAT_TO_FIXED (x2),
                            CLUTTER_FLOAT_TO_FIXED (y2),
                            CLUTTER_FLOAT_TO_FIXED (tx1),
                            CLUTTER_FLOAT_TO_FIXED (ty1),
                            CLUTTER_FLOAT_TO_FIXED (tx2),
                            CLUTTER_FLOAT_TO_FIXED (ty2));

    Py_INCREF (Py_None);
    return Py_None;
}
#line 277 "cogl.c"


#line 292 "cogl-texture.override"

static gboolean
get_double_as_fixed (PyObject *tuple, int index_, ClutterFixed *res)
{
    PyObject *item = PyTuple_GetItem (tuple, index_);

    if (PyInt_Check (item)) {
        int val = PyInt_AsLong (item);

        if (res) {
            *res = CLUTTER_INT_TO_FIXED (val);
            return TRUE;
        }
    }
        
    if (PyFloat_Check (item)) {
        double val = PyFloat_AsDouble (item);

        if (res) {
            *res = CLUTTER_FLOAT_TO_FIXED (val);
            return TRUE;
        }
    }

    PyErr_SetString (PyExc_TypeError, "expecting a floating point value");
    return FALSE;
}

static PyObject *
_wrap_cogl_texture_polygon (PyObject *self,
                            PyObject *args,
                            PyObject *kwargs)
{
    static char *kwlist[] = { "vertices", "use_color", NULL };
    CoglHandle hnd = COGL_INVALID_HANDLE;
    CoglTextureVertex *vertices = NULL;
    PyObject *py_vertices = Py_None;
    gboolean use_color = FALSE;
    int i, n_vertices;

    if (!PyArg_ParseTupleAndKeywords (args, kwargs, "Oi:cogl.texture_polygon", kwlist, &py_vertices, &use_color)) {
        return NULL;
    }

    hnd = pyg_boxed_get (self, CoglHandle);

    if (!PyTuple_Check (py_vertices)) {
        PyErr_SetString (PyExc_TypeError, "vertices must be a tuple");
        return NULL;
    }

    n_vertices = PyTuple_Size (py_vertices);
    vertices = g_new (CoglTextureVertex, n_vertices);

    for (i = 0; i < n_vertices; i++) {
        PyObject *py_vertex = PyTuple_GetItem (py_vertices, i);

        if (!PyTuple_Check (py_vertex) &&
            (PyTuple_Size (py_vertex) != 5 || PyTuple_Size (py_vertex) != 6)) {
            PyErr_SetString (PyExc_TypeError, "expecting a 5-tuple (x, y, z, tx, ty) "
                                              "or a 6-tuple (x, y, z, tx, ty, color)");
            g_free (vertices);
            return NULL;
        }

        if (!get_double_as_fixed (py_vertex, 0, &(vertices[i].x)) ||
            !get_double_as_fixed (py_vertex, 1, &(vertices[i].y)) ||
            !get_double_as_fixed (py_vertex, 2, &(vertices[i].z))) {
            g_free (vertices);
            return NULL;
        }

        if (!get_double_as_fixed (py_vertex, 3, &(vertices[i].tx)) ||
            !get_double_as_fixed (py_vertex, 4, &(vertices[i].ty))) {
            g_free (vertices);
            return NULL;
        }

        if (PyTuple_Size (py_vertex) == 6) {
            PyObject *py_color = PyTuple_GetItem (py_vertex, 5);

            if (!pyclutter_color_from_pyobject (py_color, &(vertices[i].color))) {
                PyErr_SetString (PyExc_TypeError, "expecting a clutter.Color as "
                                                  "the 6th element of the vertex "
                                                  "tuple");
                g_free (vertices);
                return NULL;
            }
        }
    }

    cogl_texture_polygon (hnd, n_vertices, vertices, use_color);
    g_free (vertices);

    Py_INCREF (Py_None);
    return Py_None;
}
#line 378 "cogl.c"


static const PyMethodDef _PyCoglHandle_methods[] = {
    { "is_texture", (PyCFunction)_wrap_cogl_is_texture, METH_NOARGS,
      NULL },
    { "get_width", (PyCFunction)_wrap_cogl_texture_get_width, METH_NOARGS,
      NULL },
    { "get_height", (PyCFunction)_wrap_cogl_texture_get_height, METH_NOARGS,
      NULL },
    { "get_format", (PyCFunction)_wrap_cogl_texture_get_format, METH_NOARGS,
      NULL },
    { "get_rowstride", (PyCFunction)_wrap_cogl_texture_get_rowstride, METH_NOARGS,
      NULL },
    { "get_rowstride", (PyCFunction)_wrap_cogl_texture_get_max_waste, METH_NOARGS,
      NULL },
    { "get_min_filter", (PyCFunction)_wrap_cogl_texture_get_min_filter, METH_NOARGS,
      NULL },
    { "get_mag_filter", (PyCFunction)_wrap_cogl_texture_get_mag_filter, METH_NOARGS,
      NULL },
    { "is_sliced", (PyCFunction)_wrap_cogl_texture_is_sliced, METH_NOARGS,
      NULL },
    { "get_gl_texture", (PyCFunction)_wrap_cogl_texture_get_gl_texture, METH_NOARGS,
      NULL },
    { "set_filters", (PyCFunction)_wrap_cogl_texture_set_filters, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "texture_rectangle", (PyCFunction)_wrap_cogl_texture_rectangle, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "texture_polygon", (PyCFunction)_wrap_cogl_texture_polygon, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { NULL, NULL, 0, NULL }
};

PyTypeObject G_GNUC_INTERNAL PyCoglHandle_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "clutter.cogl.Handle",                   /* tp_name */
    sizeof(PyGBoxed),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    0,             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyCoglHandle_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)0,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    0,                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- functions ----------- */

static PyObject *
_wrap_cogl_check_extension(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "name", "extension", NULL };
    char *name, *extension;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ss:check_extension", kwlist, &name, &extension))
        return NULL;
    
    ret = cogl_check_extension(name, extension);
    
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_cogl_get_features(PyObject *self)
{
    guint ret;

    
    ret = cogl_get_features();
    
    return pyg_flags_from_gtype(PYCOGL_TYPE_FEATURE_FLAGS, ret);
}

static PyObject *
_wrap_cogl_features_available(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "features", NULL };
    CoglFeatureFlags features;
    PyObject *py_features = NULL;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:features_available", kwlist, &py_features))
        return NULL;
    if (pyg_flags_get_value(PYCOGL_TYPE_FEATURE_FLAGS, py_features, (gpointer)&features))
        return NULL;
    
    ret = cogl_features_available(features);
    
    return PyBool_FromLong(ret);

}

#line 175 "./cogl.override"
static PyObject *
_wrap_cogl_get_bitmasks (PyObject *self)
{
  gint red, green, blue, alpha;

  cogl_get_bitmasks (&red, &green, &blue, &alpha);

  return Py_BuildValue ("(iiii)", red, green, blue, alpha);
}
#line 516 "cogl.c"


static PyObject *
_wrap_cogl_push_matrix(PyObject *self)
{
    
    cogl_push_matrix();
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_pop_matrix(PyObject *self)
{
    
    cogl_pop_matrix();
    
    Py_INCREF(Py_None);
    return Py_None;
}

#line 186 "./cogl.override"
static PyObject *
_wrap_cogl_scale (PyObject *self, PyObject *args, PyObject *kwargs)
{
  static char *kwlist[] = { "scale_x", "scale_y", NULL };
  float scale_x, scale_y;

  scale_x = scale_y = 0;

  if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ff:scale", kwlist, &scale_x, &scale_y))
    return NULL;
    
  cogl_scale (CLUTTER_FLOAT_TO_FIXED (scale_x),
              CLUTTER_FLOAT_TO_FIXED (scale_y));

  Py_INCREF (Py_None);
  return Py_None;
}
#line 557 "cogl.c"


#line 205 "./cogl.override"
static PyObject *
_wrap_cogl_translate (PyObject *self, PyObject *args, PyObject *kwargs)
{
  static char *kwlist[] = { "x", "y", "z", NULL };
  float x, y, z;

  x = y = z = 0;

  if (!PyArg_ParseTupleAndKeywords(args, kwargs,"fff:translate", kwlist, &x, &y, &z))
    return NULL;
    
  cogl_translatex (CLUTTER_FLOAT_TO_FIXED (x),
                   CLUTTER_FLOAT_TO_FIXED (y),
                   CLUTTER_FLOAT_TO_FIXED (z));

  Py_INCREF (Py_None);
  return Py_None;
}
#line 579 "cogl.c"


#line 225 "./cogl.override"
static PyObject *
_wrap_cogl_rotate (PyObject *self, PyObject *args, PyObject *kwargs)
{
  static char *kwlist[] = { "angle", "x", "y", "z", NULL };
  float angle;
  int x, y, z;

  angle = 0;
  x = y = z = 0;

  if (!PyArg_ParseTupleAndKeywords(args, kwargs,"fiii:rotate", kwlist, &angle, &x, &y, &z))
    return NULL;
    
  cogl_rotatex (CLUTTER_FLOAT_TO_FIXED (angle), x, y, z);

  Py_INCREF (Py_None);
  return Py_None;
}
#line 601 "cogl.c"


#line 82 "./cogl.override"
static PyObject *
_wrap_cogl_perspective (PyObject *self,
                        PyObject *args,
                        PyObject *kwargs)
{
  static char *kwlist[] = { "fovy", "aspect", "z_near", "z_far", NULL };
  float fovy, aspect, z_near, z_far;

  fovy = aspect = z_near = z_far = 0.0;

  if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ffff:perspective", kwlist, &fovy, &aspect, &z_near, &z_far))
    return NULL;
    
  cogl_perspective (CLUTTER_FLOAT_TO_FIXED (fovy),
                    CLUTTER_FLOAT_TO_FIXED (aspect),
                    CLUTTER_FLOAT_TO_FIXED (z_near),
                    CLUTTER_FLOAT_TO_FIXED (z_far));

  Py_INCREF (Py_None);
  return Py_None;
}
#line 626 "cogl.c"


#line 105 "./cogl.override"
static PyObject *
_wrap_cogl_frustum (PyObject *self,
                    PyObject *args,
                    PyObject *kwargs)
{
  static char *kwlist[] = { "left", "right", "bottom", "top", "z_near", "z_far", NULL };
  float left, right, bottom, top;
  float z_near, z_far;

  left = right = bottom = top = 0;
  z_near = z_far = 0.0;

  if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ffffff:perspective", kwlist, &left, &right, &bottom, &top, &z_near, &z_far))
    return NULL;
    
  cogl_frustum (CLUTTER_FLOAT_TO_FIXED (left),
                CLUTTER_FLOAT_TO_FIXED (right),
                CLUTTER_FLOAT_TO_FIXED (bottom),
                CLUTTER_FLOAT_TO_FIXED (top),
                CLUTTER_FLOAT_TO_FIXED (z_near),
                CLUTTER_FLOAT_TO_FIXED (z_far));

  Py_INCREF (Py_None);
  return Py_None;
}
#line 655 "cogl.c"


static PyObject *
_wrap_cogl_viewport(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "width", "height", NULL };
    PyObject *py_width = NULL, *py_height = NULL;
    guint width = 0, height = 0;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"OO:viewport", kwlist, &py_width, &py_height))
        return NULL;
    if (py_width) {
        if (PyLong_Check(py_width))
            width = PyLong_AsUnsignedLong(py_width);
        else if (PyInt_Check(py_width))
            width = PyInt_AsLong(py_width);
        else
            PyErr_SetString(PyExc_TypeError, "Parameter 'width' must be an int or a long");
        if (PyErr_Occurred())
            return NULL;
    }
    if (py_height) {
        if (PyLong_Check(py_height))
            height = PyLong_AsUnsignedLong(py_height);
        else if (PyInt_Check(py_height))
            height = PyInt_AsLong(py_height);
        else
            PyErr_SetString(PyExc_TypeError, "Parameter 'height' must be an int or a long");
        if (PyErr_Occurred())
            return NULL;
    }
    
    cogl_viewport(width, height);
    
    Py_INCREF(Py_None);
    return Py_None;
}

#line 132 "./cogl.override"
static PyObject *
_wrap_cogl_get_viewport (PyObject *self)
{
  ClutterFixed viewport[4] = { 0, };

  cogl_get_viewport (viewport);

  return Py_BuildValue ("(ffff)",
                        CLUTTER_FIXED_TO_FLOAT (viewport[0]),
                        CLUTTER_FIXED_TO_FLOAT (viewport[1]),
                        CLUTTER_FIXED_TO_FLOAT (viewport[2]),
                        CLUTTER_FIXED_TO_FLOAT (viewport[3]));
}
#line 708 "cogl.c"


#line 147 "./cogl.override"
static PyObject *
_wrap_cogl_setup_viewport (PyObject *self,
                           PyObject *args,
                           PyObject *kwargs)
{
  static char *kwlist[] = { "width", "height", "fovy", "aspect", "z_near", "z_far", NULL };
  guint width, height;
  float fovy, aspect;
  float z_near, z_far;

  width = height = 0;
  fovy = aspect = 0.0;
  z_near = z_far = 0.0;

  if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ddffff:perspective", kwlist, &width, &height, &fovy, &aspect, &z_near, &z_far))
    return NULL;
    
  cogl_setup_viewport (width, height,
                       CLUTTER_FLOAT_TO_FIXED (fovy),
                       CLUTTER_FLOAT_TO_FIXED (aspect),
                       CLUTTER_FLOAT_TO_FIXED (z_near),
                       CLUTTER_FLOAT_TO_FIXED (z_far));

  Py_INCREF (Py_None);
  return Py_None;
}
#line 738 "cogl.c"


static PyObject *
_wrap_cogl_clip_set(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "x_offset", "y_offset", "width", "height", NULL };
    int x_offset, y_offset, width, height;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"iiii:clip_set", kwlist, &x_offset, &y_offset, &width, &height))
        return NULL;
    
    cogl_clip_set(x_offset, y_offset, width, height);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_clip_unset(PyObject *self)
{
    
    cogl_clip_unset();
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_enable_depth_test(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "enable", NULL };
    int enable;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"i:enable_depth_test", kwlist, &enable))
        return NULL;
    
    cogl_enable_depth_test(enable);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_paint_init(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "color", NULL };
    ClutterColor *color = NULL;
    PyObject *py_color;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:paint_init", kwlist, &py_color))
        return NULL;
    if (pyg_boxed_check(py_color, CLUTTER_TYPE_COLOR))
        color = pyg_boxed_get(py_color, ClutterColor);
    else {
        PyErr_SetString(PyExc_TypeError, "color should be a ClutterColor");
        return NULL;
    }
    
    cogl_paint_init(color);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_color(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "color", NULL };
    ClutterColor *color = NULL;
    PyObject *py_color;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:color", kwlist, &py_color))
        return NULL;
    if (pyg_boxed_check(py_color, CLUTTER_TYPE_COLOR))
        color = pyg_boxed_get(py_color, ClutterColor);
    else {
        PyErr_SetString(PyExc_TypeError, "color should be a ClutterColor");
        return NULL;
    }
    
    cogl_color(color);
    
    Py_INCREF(Py_None);
    return Py_None;
}

#line 245 "./cogl.override"
static PyObject *
_wrap_cogl_rectangle (PyObject *self, PyObject *args, PyObject *kwargs)
{
  static char *kwlist[] = { "x", "y", "width", "height", NULL };
  float x, y, width, height;

  x = y = width = height = 0;

  if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ffff:rectangle", kwlist, &x, &y, &width, &height))
    return NULL;
    
  cogl_rectanglex (CLUTTER_FLOAT_TO_FIXED (x),
                   CLUTTER_FLOAT_TO_FIXED (y),
                   CLUTTER_FLOAT_TO_FIXED (width),
                   CLUTTER_FLOAT_TO_FIXED (height));

  Py_INCREF (Py_None);
  return Py_None;
}
#line 845 "cogl.c"


static PyObject *
_wrap_cogl_path_fill(PyObject *self)
{
    
    cogl_path_fill();
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_path_stroke(PyObject *self)
{
    
    cogl_path_stroke();
    
    Py_INCREF(Py_None);
    return Py_None;
}

#line 266 "./cogl.override"
static PyObject *
_wrap_cogl_path_move_to (PyObject *self, PyObject *args, PyObject *kwargs)
{
  static char *kwlist[] = { "x", "y", NULL };
  float x, y;

  x = y = 0;

  if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ff:path_move_to", kwlist, &x, &y))
    return NULL;
    
  cogl_path_move_to (CLUTTER_FLOAT_TO_FIXED (x),
                     CLUTTER_FLOAT_TO_FIXED (y));

  Py_INCREF (Py_None);
  return Py_None;
}
#line 886 "cogl.c"


#line 285 "./cogl.override"
static PyObject *
_wrap_cogl_path_rel_move_to (PyObject *self, PyObject *args, PyObject *kwargs)
{
  static char *kwlist[] = { "x", "y", NULL };
  float x, y;

  x = y = 0;

  if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ff:path_rel_move_to", kwlist, &x, &y))
    return NULL;
    
  cogl_path_rel_move_to (CLUTTER_FLOAT_TO_FIXED (x),
                         CLUTTER_FLOAT_TO_FIXED (y));

  Py_INCREF (Py_None);
  return Py_None;
}
#line 907 "cogl.c"


#line 304 "./cogl.override"
static PyObject *
_wrap_cogl_path_line_to (PyObject *self, PyObject *args, PyObject *kwargs)
{
  static char *kwlist[] = { "x", "y", NULL };
  float x, y;

  x = y = 0;

  if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ff:path_line_to", kwlist, &x, &y))
    return NULL;
    
  cogl_path_line_to (CLUTTER_FLOAT_TO_FIXED (x),
                     CLUTTER_FLOAT_TO_FIXED (y));

  Py_INCREF (Py_None);
  return Py_None;
}
#line 928 "cogl.c"


#line 323 "./cogl.override"
static PyObject *
_wrap_cogl_path_rel_line_to (PyObject *self, PyObject *args, PyObject *kwargs)
{
  static char *kwlist[] = { "x", "y", NULL };
  float x, y;

  x = y = 0;

  if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ff:path_rel_line_to", kwlist, &x, &y))
    return NULL;
    
  cogl_path_rel_line_to (CLUTTER_FLOAT_TO_FIXED (x),
                         CLUTTER_FLOAT_TO_FIXED (y));

  Py_INCREF (Py_None);
  return Py_None;
}
#line 949 "cogl.c"


static PyObject *
_wrap_cogl_path_close(PyObject *self)
{
    
    cogl_path_close();
    
    Py_INCREF(Py_None);
    return Py_None;
}

#line 342 "./cogl.override"
static PyObject *
_wrap_cogl_path_arc (PyObject *self, PyObject *args, PyObject *kwargs)
{
  static char *kwlist[] = { "center_x", "center_y", "radius_x", "radius_y", "angle_start", "angle_end", NULL };
  float center_x, center_y, radius_x, radius_y, angle_start, angle_end;

  center_x = center_y = 0;
  radius_x = radius_y = 0;
  angle_start = angle_end = 0;

  if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ffffff:path_arc", kwlist, &center_x, &center_y, &radius_x, &radius_y, &angle_start, &angle_end))
    return NULL;
    
  cogl_path_arc (CLUTTER_FLOAT_TO_FIXED (center_x),
                 CLUTTER_FLOAT_TO_FIXED (center_y),
                 CLUTTER_FLOAT_TO_FIXED (radius_x),
                 CLUTTER_FLOAT_TO_FIXED (radius_y),
                 CLUTTER_ANGLE_FROM_DEGF (angle_start),
                 CLUTTER_ANGLE_FROM_DEGF (angle_end));

  Py_INCREF (Py_None);
  return Py_None;
}
#line 986 "cogl.c"


#line 367 "./cogl.override"
static PyObject *
_wrap_cogl_path_curve_to (PyObject *self, PyObject *args, PyObject *kwargs)
{
  static char *kwlist[] = { "x1", "y1", "x2", "y2", "x3", "y3", NULL };
  float x1, y1, x2, y2, x3, y3;

  x1 = y1 = x2 = y2 = x3 = y3 = 0;

  if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ffffff:path_curve_to", kwlist, &x1, &y1, &x2, &y2, &x3, &y3))
    return NULL;
    
  cogl_path_curve_to (CLUTTER_FLOAT_TO_FIXED (x1),
                      CLUTTER_FLOAT_TO_FIXED (y1),
                      CLUTTER_FLOAT_TO_FIXED (x2),
                      CLUTTER_FLOAT_TO_FIXED (y2),
                      CLUTTER_FLOAT_TO_FIXED (x3),
                      CLUTTER_FLOAT_TO_FIXED (y3));

  Py_INCREF (Py_None);
  return Py_None;
}
#line 1011 "cogl.c"


#line 390 "./cogl.override"
static PyObject *
_wrap_cogl_path_rel_curve_to (PyObject *self, PyObject *args, PyObject *kwargs)
{
  static char *kwlist[] = { "x1", "y1", "x2", "y2", "x3", "y3", NULL };
  float x1, y1, x2, y2, x3, y3;

  x1 = y1 = x2 = y2 = x3 = y3 = 0;

  if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ffffff:path_rel_curve_to", kwlist, &x1, &y1, &x2, &y2, &x3, &y3))
    return NULL;
    
  cogl_path_rel_curve_to (CLUTTER_FLOAT_TO_FIXED (x1),
                          CLUTTER_FLOAT_TO_FIXED (y1),
                          CLUTTER_FLOAT_TO_FIXED (x2),
                          CLUTTER_FLOAT_TO_FIXED (y2),
                          CLUTTER_FLOAT_TO_FIXED (x3),
                          CLUTTER_FLOAT_TO_FIXED (y3));

  Py_INCREF (Py_None);
  return Py_None;
}
#line 1036 "cogl.c"


#line 413 "./cogl.override"
static PyObject *
_wrap_cogl_path_line (PyObject *self, PyObject *args, PyObject *kwargs)
{
  static char *kwlist[] = { "x1", "y1", "x2", "y2", NULL };
  float x1, y1, x2, y2;

  x1 = y1 = x2 = y2 = 0;

  if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ffff:path_line_to", kwlist, &x1, &y1, &x2, &y2))
    return NULL;
    
  cogl_path_line (CLUTTER_FLOAT_TO_FIXED (x1),
                  CLUTTER_FLOAT_TO_FIXED (y1),
                  CLUTTER_FLOAT_TO_FIXED (x2),
                  CLUTTER_FLOAT_TO_FIXED (y2));

  Py_INCREF (Py_None);
  return Py_None;
}
#line 1059 "cogl.c"


#line 434 "./cogl.override"
static PyObject *
_wrap_cogl_path_rectangle (PyObject *self, PyObject *args, PyObject *kwargs)
{
  static char *kwlist[] = { "x", "y", "width", "height", NULL };
  float x, y, width, height;

  x = y = 0;
  width = height = 0;

  if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ffff:path_rectangle", kwlist, &x, &y, &width, &height))
    return NULL;
    
  cogl_path_rectangle (CLUTTER_FLOAT_TO_FIXED (x),
                       CLUTTER_FLOAT_TO_FIXED (y),
                       CLUTTER_FLOAT_TO_FIXED (width),
                       CLUTTER_FLOAT_TO_FIXED (height));

  Py_INCREF (Py_None);
  return Py_None;
}
#line 1083 "cogl.c"


#line 456 "./cogl.override"
static PyObject *
_wrap_cogl_path_ellipse (PyObject *self, PyObject *args, PyObject *kwargs)
{
  static char *kwlist[] = { "center_x", "center_y", "radius_x", "radius_y", NULL };
  float center_x, center_y, radius_x, radius_y;

  center_x = center_y = 0;
  radius_x = radius_y = 0;

  if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ffff:path_ellipse", kwlist, &center_x, &center_y, &radius_x, &radius_y))
    return NULL;
    
  cogl_path_ellipse (CLUTTER_FLOAT_TO_FIXED (center_x),
                     CLUTTER_FLOAT_TO_FIXED (center_y),
                     CLUTTER_FLOAT_TO_FIXED (radius_x),
                     CLUTTER_FLOAT_TO_FIXED (radius_y));

  Py_INCREF (Py_None);
  return Py_None;
}
#line 1107 "cogl.c"


#line 478 "./cogl.override"
static PyObject *
_wrap_cogl_path_round_rectangle (PyObject *self, PyObject *args, PyObject *kwargs)
{
  static char *kwlist[] = { "x", "y", "width", "height", "radius", "angle_step", NULL };
  float x, y, width, height, radius, angle_step;

  x = y = width = height = 0;
  radius = angle_step = 0;

  if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ffffff:path_round_rectangle", kwlist, &x, &y, &width, &height, &radius, &angle_step))
    return NULL;
    
  cogl_path_round_rectangle (CLUTTER_FLOAT_TO_FIXED (x),
                             CLUTTER_FLOAT_TO_FIXED (y),
                             CLUTTER_FLOAT_TO_FIXED (width),
                             CLUTTER_FLOAT_TO_FIXED (height),
                             CLUTTER_FLOAT_TO_FIXED (radius),
                             CLUTTER_ANGLE_FROM_DEGF (angle_step));

  Py_INCREF (Py_None);
  return Py_None;
}
#line 1133 "cogl.c"


#line 3 "cogl-texture.override"
static PyObject *
_wrap_cogl_texture_new_with_size (PyObject *self,
                                  PyObject *args,
                                  PyObject *kwargs)
{
    static char *kwlist[] = { "width", "height", "max_waste", "auto_mipmap", "internal_format", NULL };
    PyObject *py_width = NULL, *py_height = NULL, *py_internal_format = NULL;
    int max_waste, auto_mipmap;
    CoglPixelFormat internal_format;
    guint width = 0, height = 0;
    CoglHandle ret = COGL_INVALID_HANDLE;

    if (!PyArg_ParseTupleAndKeywords (args, kwargs, "OOiiO:texture_new_with_size", kwlist, &py_width, &py_height, &max_waste, &auto_mipmap, &py_internal_format))
        return NULL;

    if (py_width) {
        if (PyLong_Check (py_width))
            width = PyLong_AsUnsignedLong (py_width);
        else if (PyInt_Check (py_width))
            width = PyInt_AsLong (py_width);
        else
            PyErr_SetString (PyExc_TypeError, "Parameter 'width' must be an int or a long");
        if (PyErr_Occurred ())
            return NULL;
    }

    if (py_height) {
        if (PyLong_Check (py_height))
            height = PyLong_AsUnsignedLong (py_height);
        else if (PyInt_Check (py_height))
            height = PyInt_AsLong (py_height);
        else
            PyErr_SetString (PyExc_TypeError, "Parameter 'height' must be an int or a long");
        if (PyErr_Occurred ())
            return NULL;
    }

    if (pyg_enum_get_value (PYCOGL_TYPE_PIXEL_FORMAT, py_internal_format, (gpointer)&internal_format))
        return NULL;

    ret = cogl_texture_new_with_size (width, height,
                                      max_waste,
                                      auto_mipmap,
                                      internal_format);

    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new (PYCOGL_TYPE_HANDLE, ret, TRUE, TRUE);
}
#line 1185 "cogl.c"


#line 53 "cogl-texture.override"
static PyObject *
_wrap_cogl_texture_new_from_file (PyObject *self,
                                  PyObject *args,
                                  PyObject *kwargs)
{
    static char *kwlist[] = { "filename", "max_waste", "auto_mipmap", "internal_format", NULL };
    int max_waste, auto_mipmap;
    CoglPixelFormat internal_format;
    GError *error = NULL;
    char *filename;
    PyObject *py_internal_format = NULL;
    CoglHandle ret = COGL_INVALID_HANDLE;

    if (!PyArg_ParseTupleAndKeywords (args, kwargs,"siiO:texture_new_from_file", kwlist, &filename, &max_waste, &auto_mipmap, &py_internal_format))
        return NULL;

    if (pyg_enum_get_value (PYCOGL_TYPE_PIXEL_FORMAT, py_internal_format, (gpointer)&internal_format))
        return NULL;

    ret = cogl_texture_new_from_file (filename,
                                      max_waste,
                                      auto_mipmap,
                                      internal_format,
                                      &error);

    if (pyg_error_check (&error))
        return NULL;

    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new (PYCOGL_TYPE_HANDLE, ret, TRUE, TRUE);
}
#line 1220 "cogl.c"


#line 86 "cogl-texture.override"
static PyObject *
_wrap_cogl_texture_new_from_data (PyObject *self,
                                  PyObject *args,
                                  PyObject *kwargs)
{
    static char *kwlist[] = { "width", "height", "max_waste", "auto_mipmap", "format", "internal_format", "rowstride", "data", NULL };
    PyObject *py_width = NULL, *py_height = NULL, *py_format = NULL, *py_internal_format = NULL, *py_rowstride = NULL;
    CoglPixelFormat format, internal_format;
    guint width = 0, height = 0, rowstride = 0;
    int max_waste, auto_mipmap;
    guchar *data;
    CoglHandle ret = COGL_INVALID_HANDLE;
    Py_ssize_t data_len;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"OOiiOOOs#:texture_new_from_data", kwlist, &py_width, &py_height, &max_waste, &auto_mipmap, &py_format, &py_internal_format, &py_rowstride, &data, &data_len))
        return NULL;

    if (py_width) {
        if (PyLong_Check (py_width))
            width = PyLong_AsUnsignedLong (py_width);
        else if (PyInt_Check (py_width))
            width = PyInt_AsLong (py_width);
        else
            PyErr_SetString (PyExc_TypeError, "Parameter 'width' must be an int or a long");

        if (PyErr_Occurred ())
            return NULL;
    }

    if (py_height) {
        if (PyLong_Check (py_height))
            height = PyLong_AsUnsignedLong (py_height);
        else if (PyInt_Check (py_height))
            height = PyInt_AsLong (py_height);
        else
            PyErr_SetString (PyExc_TypeError, "Parameter 'height' must be an int or a long");

        if (PyErr_Occurred ())
            return NULL;
    }

    if (pyg_enum_get_value (PYCOGL_TYPE_PIXEL_FORMAT, py_format, (gpointer)&format))
        return NULL;

    if (pyg_enum_get_value (PYCOGL_TYPE_PIXEL_FORMAT, py_internal_format, (gpointer)&internal_format))
        return NULL;

    if (py_rowstride) {
        if (PyLong_Check (py_rowstride))
            rowstride = PyLong_AsUnsignedLong (py_rowstride);
        else if (PyInt_Check (py_rowstride))
            rowstride = PyInt_AsLong (py_rowstride);
        else
            PyErr_SetString (PyExc_TypeError, "Parameter 'rowstride' must be an int or a long");

        if (PyErr_Occurred ())
            return NULL;
    }

    ret = cogl_texture_new_from_data (width, height,
                                      max_waste,
                                      auto_mipmap,
                                      format, internal_format,
                                      rowstride,
                                      data);

    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new (PYCOGL_TYPE_HANDLE, ret, TRUE, TRUE);
}
#line 1293 "cogl.c"


#line 157 "cogl-texture.override"
static PyObject *
_wrap_cogl_texture_new_from_foreign (PyObject *self,
                                     PyObject *args,
                                     PyObject *kwargs)
{
    static char *kwlist[] = { "gl_handle", "gl_target", "width", "height", "x_pot_waste", "y_pot_waste", "format", NULL };
    PyObject *py_gl_handle = NULL, *py_width = NULL, *py_height = NULL, *py_x_pot_waste = NULL, *py_y_pot_waste = NULL, *py_format = NULL;
    int gl_target;
    CoglPixelFormat format;
    guint gl_handle = 0, width = 0, height = 0, x_pot_waste = 0, y_pot_waste = 0;
    CoglHandle ret = COGL_INVALID_HANDLE;

    if (!PyArg_ParseTupleAndKeywords (args, kwargs,"OiOOOOO:texture_new_from_foreign", kwlist, &py_gl_handle, &gl_target, &py_width, &py_height, &py_x_pot_waste, &py_y_pot_waste, &py_format))
        return NULL;

    if (py_gl_handle) {
        if (PyLong_Check (py_gl_handle))
            gl_handle = PyLong_AsUnsignedLong (py_gl_handle);
        else if (PyInt_Check (py_gl_handle))
            gl_handle = PyInt_AsLong (py_gl_handle);
        else
            PyErr_SetString (PyExc_TypeError, "Parameter 'gl_handle' must be an int or a long");

        if (PyErr_Occurred ())
            return NULL;
    }

    if (py_width) {
        if (PyLong_Check (py_width))
            width = PyLong_AsUnsignedLong (py_width);
        else if (PyInt_Check (py_width))
            width = PyInt_AsLong (py_width);
        else
            PyErr_SetString (PyExc_TypeError, "Parameter 'width' must be an int or a long");

        if (PyErr_Occurred ())
            return NULL;
    }

    if (py_height) {
        if (PyLong_Check (py_height))
            height = PyLong_AsUnsignedLong (py_height);
        else if (PyInt_Check (py_height))
            height = PyInt_AsLong (py_height);
        else
            PyErr_SetString (PyExc_TypeError, "Parameter 'height' must be an int or a long");

        if (PyErr_Occurred ())
            return NULL;
    }

    if (py_x_pot_waste) {
        if (PyLong_Check (py_x_pot_waste))
            x_pot_waste = PyLong_AsUnsignedLong (py_x_pot_waste);
        else if (PyInt_Check (py_x_pot_waste))
            x_pot_waste = PyInt_AsLong (py_x_pot_waste);
        else
            PyErr_SetString (PyExc_TypeError, "Parameter 'x_pot_waste' must be an int or a long");

        if (PyErr_Occurred ())
            return NULL;
    }

    if (py_y_pot_waste) {
        if (PyLong_Check (py_y_pot_waste))
            y_pot_waste = PyLong_AsUnsignedLong (py_y_pot_waste);
        else if (PyInt_Check (py_y_pot_waste))
            y_pot_waste = PyInt_AsLong (py_y_pot_waste);
        else
            PyErr_SetString (PyExc_TypeError, "Parameter 'y_pot_waste' must be an int or a long");

        if (PyErr_Occurred ())
            return NULL;
    }

    if (pyg_enum_get_value (PYCOGL_TYPE_PIXEL_FORMAT, py_format, (gpointer)&format))
        return NULL;

    ret = cogl_texture_new_from_foreign (gl_handle, gl_target,
                                         width, height,
                                         x_pot_waste, y_pot_waste,
                                         format);

    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new (PYCOGL_TYPE_HANDLE, ret, TRUE, TRUE);
}
#line 1383 "cogl.c"


const PyMethodDef pycogl_functions[] = {
    { "check_extension", (PyCFunction)_wrap_cogl_check_extension, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_features", (PyCFunction)_wrap_cogl_get_features, METH_NOARGS,
      NULL },
    { "features_available", (PyCFunction)_wrap_cogl_features_available, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_bitmasks", (PyCFunction)_wrap_cogl_get_bitmasks, METH_NOARGS,
      NULL },
    { "push_matrix", (PyCFunction)_wrap_cogl_push_matrix, METH_NOARGS,
      NULL },
    { "pop_matrix", (PyCFunction)_wrap_cogl_pop_matrix, METH_NOARGS,
      NULL },
    { "scale", (PyCFunction)_wrap_cogl_scale, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "translate", (PyCFunction)_wrap_cogl_translate, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "rotate", (PyCFunction)_wrap_cogl_rotate, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "perspective", (PyCFunction)_wrap_cogl_perspective, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "frustum", (PyCFunction)_wrap_cogl_frustum, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "viewport", (PyCFunction)_wrap_cogl_viewport, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_viewport", (PyCFunction)_wrap_cogl_get_viewport, METH_NOARGS,
      NULL },
    { "setup_viewport", (PyCFunction)_wrap_cogl_setup_viewport, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "clip_set", (PyCFunction)_wrap_cogl_clip_set, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "clip_unset", (PyCFunction)_wrap_cogl_clip_unset, METH_NOARGS,
      NULL },
    { "enable_depth_test", (PyCFunction)_wrap_cogl_enable_depth_test, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "paint_init", (PyCFunction)_wrap_cogl_paint_init, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "color", (PyCFunction)_wrap_cogl_color, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "rectangle", (PyCFunction)_wrap_cogl_rectangle, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "path_fill", (PyCFunction)_wrap_cogl_path_fill, METH_NOARGS,
      NULL },
    { "path_stroke", (PyCFunction)_wrap_cogl_path_stroke, METH_NOARGS,
      NULL },
    { "path_move_to", (PyCFunction)_wrap_cogl_path_move_to, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "path_rel_move_to", (PyCFunction)_wrap_cogl_path_rel_move_to, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "path_line_to", (PyCFunction)_wrap_cogl_path_line_to, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "path_rel_line_to", (PyCFunction)_wrap_cogl_path_rel_line_to, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "path_close", (PyCFunction)_wrap_cogl_path_close, METH_NOARGS,
      NULL },
    { "path_arc", (PyCFunction)_wrap_cogl_path_arc, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "path_curve_to", (PyCFunction)_wrap_cogl_path_curve_to, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "path_rel_curve_to", (PyCFunction)_wrap_cogl_path_rel_curve_to, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "path_line", (PyCFunction)_wrap_cogl_path_line, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "path_rectangle", (PyCFunction)_wrap_cogl_path_rectangle, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "path_ellipse", (PyCFunction)_wrap_cogl_path_ellipse, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "path_round_rectangle", (PyCFunction)_wrap_cogl_path_round_rectangle, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "texture_new_with_size", (PyCFunction)_wrap_cogl_texture_new_with_size, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "texture_new_from_file", (PyCFunction)_wrap_cogl_texture_new_from_file, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "texture_new_from_data", (PyCFunction)_wrap_cogl_texture_new_from_data, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "texture_new_from_foreign", (PyCFunction)_wrap_cogl_texture_new_from_foreign, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { NULL, NULL, 0, NULL }
};


/* ----------- enums and flags ----------- */

void
pycogl_add_constants(PyObject *module, const gchar *strip_prefix)
{
#ifdef VERSION
    PyModule_AddStringConstant(module, "__version__", VERSION);
#endif
  pyg_enum_add(module, "PixelFormat", strip_prefix, PYCOGL_TYPE_PIXEL_FORMAT);
  pyg_flags_add(module, "FeatureFlags", strip_prefix, PYCOGL_TYPE_FEATURE_FLAGS);

  if (PyErr_Occurred())
    PyErr_Print();
}

/* initialise stuff extension classes */
void
pycogl_register_classes(PyObject *d)
{

#line 1487 "cogl.c"
    pyg_register_boxed(d, "Handle", PYCOGL_TYPE_HANDLE, &PyCoglHandle_Type);
}
